wayland::shell_surface_t(3)

NAME
wayland::shell_surface_t - desktop-style metadata interface

SYNOPSIS

#include <wayland-client-protocol.hpp>

Inherits wayland::proxy_t.

  Public Types

enum class wrapper_type { standard, display, foreign, proxy_wrapper }

  Public Member Functions

void pong (uint32_t serial)
respond to a ping event
void move (seat_t const &seat, uint32_t serial)
start an interactive move
void resize (seat_t const &seat, uint32_t serial, shell_surface_resize const &edges)
start an interactive resize
void set_toplevel ()
make the surface a toplevel surface
void set_transient (surface_t const &parent, int32_t x, int32_t y, shell_surface_transient const &flags)
make the surface a transient surface
void set_fullscreen (shell_surface_fullscreen_method const &method, uint32_t framerate, output_t const &output)
make the surface a fullscreen surface
void set_popup (seat_t const &seat, uint32_t serial, surface_t const &parent, int32_t x, int32_t y, shell_surface_transient const &flags)
make the surface a popup surface
void set_maximized (output_t const &output)
make the surface a maximized surface
void set_title (std::string const &title)
set surface title
void set_class (std::string const &class_)
set surface class
std::function< void(uint32_t)> & on_ping ()
ping client
std::function< void(shell_surface_resize, int32_t, int32_t)> & on_configure ()
suggest resize
std::function< void()> & on_popup_done ()
popup interaction is done
uint32_t get_id () const
Get the id of a proxy object.
std::string get_class () const
Get the interface name (class) of a proxy object.
uint32_t get_version () const
Get the protocol object version of a proxy object.
wrapper_type get_wrapper_type () const
Get the type of a proxy object.
void set_queue (event_queue_t queue)
Assign a proxy to an event queue.
wl_proxy * c_ptr () const
Get a pointer to the underlying C struct.
bool proxy_has_object () const
Check whether this wrapper actually wraps an object.
operator bool () const
Check whether this wrapper actually wraps an object.
bool operator== (const proxy_t &right) const
Check whether two wrappers refer to the same object.
bool operator!= (const proxy_t &right) const
Check whether two wrappers refer to different objects.
void proxy_release ()
Release the wrapped object (if any), making this an empty wrapper.

  Static Public Attributes

static constexpr std::uint32_t pong_since_version = 1
Minimum protocol version required for the pong function.
static constexpr std::uint32_t move_since_version = 1
Minimum protocol version required for the move function.
static constexpr std::uint32_t resize_since_version = 1
Minimum protocol version required for the resize function.
static constexpr std::uint32_t set_toplevel_since_version = 1
Minimum protocol version required for the set_toplevel function.
static constexpr std::uint32_t set_transient_since_version = 1
Minimum protocol version required for the set_transient function.
static constexpr std::uint32_t set_fullscreen_since_version = 1
Minimum protocol version required for the set_fullscreen function.
static constexpr std::uint32_t set_popup_since_version = 1
Minimum protocol version required for the set_popup function.
static constexpr std::uint32_t set_maximized_since_version = 1
Minimum protocol version required for the set_maximized function.
static constexpr std::uint32_t set_title_since_version = 1
Minimum protocol version required for the set_title function.
static constexpr std::uint32_t set_class_since_version = 1
Minimum protocol version required for the set_class function.

Detailed Description

desktop-style metadata interface

An interface that may be implemented by a wl_surface, for implementations that provide a desktop-style user interface.

It provides requests to treat surfaces like toplevel, fullscreen or popup windows, move, resize or maximize them, associate metadata like title and class, etc.

On the server side the object is automatically destroyed when the related wl_surface is destroyed. On the client side, wl_shell_surface_destroy() must be called before destroying the wl_surface object.

Examples
egl.cpp.

Definition at line 1592 of file wayland-client-protocol.hpp.

Member Enumeration Documentation

  enum class wayland::proxy_t::wrapper_type [strong], [inherited]
Underlying wl_proxy type and properties of a proxy_t that affect construction, destruction, and event handling

Enumerator

standard
    C pointer is a standard type compatible with wl_proxy*. Events are dispatched and it is destructed when the proxy_t is destructed. User data is set.

display
    C pointer is a wl_display*. No events are dispatched, wl_display_disconnect is called when the proxy_t is destructed. User data is set.

foreign
    C pointer is a standard type compatible with wl_proxy*, but another library owns it and it should not be touched in a way that could affect the operation of the other library. No events are dispatched, wl_proxy_destroy is not called when the proxy_t is destructed, user data is not touched. Consequently, there is no reference counting for the proxy_t. Lifetime of such wrappers should preferably be short to minimize the chance that the owning library decides to destroy the wl_proxy.

proxy_wrapper
    C pointer is a wl_proxy* that was constructed with wl_proxy_create_wrapper. No events are dispatched, wl_proxy_wrapper_destroy is called when the proxy_t is destroyed. Reference counting is active. A reference to the proxy_t creating this proxy wrapper is held to extend its lifetime until after the proxy wrapper is destroyed.

Definition at line 117 of file wayland-client.hpp.

Member Function Documentation

  wl_proxy * wayland::proxy_t::c_ptr () const [inherited]

Get a pointer to the underlying C struct.

Returns
    The underlying wl_proxy wrapped by this proxy_t if it exists, otherwise an exception is thrown

  std::string wayland::proxy_t::get_class () const [inherited]

Get the interface name (class) of a proxy object.

Returns
    The interface name of the object associated with the proxy

  uint32_t wayland::proxy_t::get_id () const [inherited]

Get the id of a proxy object.

Returns
    The id the object associated with the proxy

  uint32_t wayland::proxy_t::get_version () const [inherited]

Get the protocol object version of a proxy object. Gets the protocol object version of a proxy object, or 0 if the proxy was created with unversioned API.

A returned value of 0 means that no version information is available, so the caller must make safe assumptions about the object's real version.

display_t will always return version 0.

Returns
    The protocol object version of the proxy or 0

  wrapper_type wayland::proxy_t::get_wrapper_type () const [inline], [inherited]

Get the type of a proxy object.

Definition at line 303 of file wayland-client.hpp.

  void shell_surface_t::move (seat_t const & seat, uint32_t serial)

start an interactive move

Parameters
    seat seat whose pointer is used
    serial serial number of the implicit grab on the pointer

Start a pointer-driven move of the surface.

This request must be used in response to a button press event. The server may ignore move requests depending on the state of the surface (e.g. fullscreen or maximized).

Definition at line 2542 of file wayland-client-protocol.cpp.

  std::function< void(shell_surface_resize, int32_t, int32_t)> & shell_surface_t::on_configure ()

suggest resize

Parameters
    edges how the surface was resized
    width new width of the surface
    height new height of the surface

The configure event asks the client to resize its surface.

The size is a hint, in the sense that the client is free to ignore it if it doesn't resize, pick a smaller size (to satisfy aspect ratio or resize in steps of NxM pixels).

The edges parameter provides a hint about how the surface was resized. The client may use this information to decide how to adjust its content to the new size (e.g. a scrolling area might adjust its content position to leave the viewable content unmoved).

The client is free to dismiss all but the last configure event it received.

The width and height arguments specify the size of the window in surface-local coordinates.

Definition at line 2601 of file wayland-client-protocol.cpp.

  std::function< void(uint32_t)> & shell_surface_t::on_ping ()

ping client

Parameters
    serial serial number of the ping

Ping a client to check if it is receiving events and sending requests. A client is expected to reply with a pong request.

Definition at line 2596 of file wayland-client-protocol.cpp.

  std::function< void()> & shell_surface_t::on_popup_done ()

popup interaction is done The popup_done event is sent out when a popup grab is broken, that is, when the user clicks a surface that doesn't belong to the client owning the popup surface.

Definition at line 2606 of file wayland-client-protocol.cpp.

  wayland::proxy_t::operator bool () const [inherited]

Check whether this wrapper actually wraps an object.

Returns
    true if there is an underlying object, false if this wrapper is empty

  bool wayland::proxy_t::operator!= (const proxy_t & right) const [inherited]

Check whether two wrappers refer to different objects.

  bool wayland::proxy_t::operator== (const proxy_t & right) const [inherited]

Check whether two wrappers refer to the same object.

  void shell_surface_t::pong (uint32_t serial)

respond to a ping event

Parameters
    serial serial number of the ping event

A client must respond to a ping event with a pong request or the client may be deemed unresponsive.

Definition at line 2536 of file wayland-client-protocol.cpp.

  bool wayland::proxy_t::proxy_has_object () const [inherited]

Check whether this wrapper actually wraps an object.

Returns
    true if there is an underlying object, false if this wrapper is empty

  void wayland::proxy_t::proxy_release () [inherited]

Release the wrapped object (if any), making this an empty wrapper. Note that display_t instances cannot be released this way. Attempts to do so are ignored.

Examples
foreign_display.cpp.

  void shell_surface_t::resize (seat_t const & seat, uint32_t serial, shell_surface_resize const & edges)

start an interactive resize

Parameters
    seat seat whose pointer is used
    serial serial number of the implicit grab on the pointer
    edges which edge or corner is being dragged

Start a pointer-driven resizing of the surface.

This request must be used in response to a button press event. The server may ignore resize requests depending on the state of the surface (e.g. fullscreen or maximized).

Definition at line 2548 of file wayland-client-protocol.cpp.

  void shell_surface_t::set_class (std::string const & class_)

set surface class

Parameters
    class_ surface class

Set a class for the surface.

The surface class identifies the general class of applications to which the surface belongs. A common convention is to use the file name (or the full path if it is a non-standard location) of the application's .desktop file as the class.

Definition at line 2590 of file wayland-client-protocol.cpp.

  void shell_surface_t::set_fullscreen (shell_surface_fullscreen_method const & method, uint32_t framerate, output_t const & output)

make the surface a fullscreen surface

Parameters
    method method for resolving size conflict
    framerate framerate in mHz
    output output on which the surface is to be fullscreen

Map the surface as a fullscreen surface.

If an output parameter is given then the surface will be made fullscreen on that output. If the client does not specify the output then the compositor will apply its policy - usually choosing the output on which the surface has the biggest surface area.

The client may specify a method to resolve a size conflict between the output size and the surface size - this is provided through the method parameter.

The framerate parameter is used only when the method is set to "driver", to indicate the preferred framerate. A value of 0 indicates that the client does not care about framerate. The framerate is specified in mHz, that is framerate of 60000 is 60Hz.

A method of "scale" or "driver" implies a scaling operation of the surface, either via a direct scaling operation or a change of the output mode. This will override any kind of output scaling, so that mapping a surface with a buffer size equal to the mode can fill the screen independent of buffer_scale.

A method of "fill" means we don't scale up the buffer, however any output scale is applied. This means that you may run into an edge case where the application maps a buffer with the same size of the output mode but buffer_scale 1 (thus making a surface larger than the output). In this case it is allowed to downscale the results to fit the screen.

The compositor must reply to this request with a configure event with the dimensions for the output on which the surface will be made fullscreen.

Definition at line 2566 of file wayland-client-protocol.cpp.

  void shell_surface_t::set_maximized (output_t const & output)

make the surface a maximized surface

Parameters
    output output on which the surface is to be maximized

Map the surface as a maximized surface.

If an output parameter is given then the surface will be maximized on that output. If the client does not specify the output then the compositor will apply its policy - usually choosing the output on which the surface has the biggest surface area.

The compositor will reply with a configure event telling the expected new surface size. The operation is completed on the next buffer attach to this surface.

A maximized surface typically fills the entire output it is bound to, except for desktop elements such as panels. This is the main difference between a maximized shell surface and a fullscreen shell surface.

The details depend on the compositor implementation.

Definition at line 2578 of file wayland-client-protocol.cpp.

  void shell_surface_t::set_popup (seat_t const & seat, uint32_t serial, surface_t const & parent, int32_t x, int32_t y, shell_surface_transient const & flags)

make the surface a popup surface

Parameters
    seat seat whose pointer is used
    serial serial number of the implicit grab on the pointer
    parent parent surface
    x surface-local x coordinate
    y surface-local y coordinate
    flags transient surface behavior

Map the surface as a popup.

A popup surface is a transient surface with an added pointer grab.

An existing implicit grab will be changed to owner-events mode, and the popup grab will continue after the implicit grab ends (i.e. releasing the mouse button does not cause the popup to be unmapped).

The popup grab continues until the window is destroyed or a mouse button is pressed in any other client's window. A click in any of the client's surfaces is reported as normal, however, clicks in other clients' surfaces will be discarded and trigger the callback.

The x and y arguments specify the location of the upper left corner of the surface relative to the upper left corner of the parent surface, in surface-local coordinates.

Definition at line 2572 of file wayland-client-protocol.cpp.

  void wayland::proxy_t::set_queue (event_queue_t queue) [inherited]

Assign a proxy to an event queue.

Parameters
    queue The event queue that will handle this proxy

Assign proxy to event queue. Events coming from proxy will be queued in queue instead of the display's main queue.

See also: display_t::dispatch_queue().

Examples
proxy_wrapper.cpp.

  void shell_surface_t::set_title (std::string const & title)

set surface title

Parameters
    title surface title

Set a short title for the surface.

This string may be used to identify the surface in a task bar, window list, or other user interface elements provided by the compositor.

The string must be encoded in UTF-8.

Definition at line 2584 of file wayland-client-protocol.cpp.

  void shell_surface_t::set_toplevel ()

make the surface a toplevel surface Map the surface as a toplevel surface.

A toplevel surface is not fullscreen, maximized or transient.

Definition at line 2554 of file wayland-client-protocol.cpp.

  void shell_surface_t::set_transient (surface_t const & parent, int32_t x, int32_t y, shell_surface_transient const & flags)

make the surface a transient surface

Parameters
    parent parent surface
    x surface-local x coordinate
    y surface-local y coordinate
    flags transient surface behavior

Map the surface relative to an existing surface.

The x and y arguments specify the location of the upper left corner of the surface relative to the upper left corner of the parent surface, in surface-local coordinates.

The flags argument controls details of the transient behaviour.

Definition at line 2560 of file wayland-client-protocol.cpp.

Member Data Documentation

  std::uint32_t wayland::shell_surface_t::move_since_version = 1 [static], [constexpr]

Minimum protocol version required for the move function.

Definition at line 1645 of file wayland-client-protocol.hpp.

  std::uint32_t wayland::shell_surface_t::pong_since_version = 1 [static], [constexpr]

Minimum protocol version required for the pong function.

Definition at line 1628 of file wayland-client-protocol.hpp.

  std::uint32_t wayland::shell_surface_t::resize_since_version = 1 [static], [constexpr]

Minimum protocol version required for the resize function.

Definition at line 1663 of file wayland-client-protocol.hpp.

  std::uint32_t wayland::shell_surface_t::set_class_since_version = 1 [static], [constexpr]

Minimum protocol version required for the set_class function.

Definition at line 1842 of file wayland-client-protocol.hpp.

  std::uint32_t wayland::shell_surface_t::set_fullscreen_since_version = 1 [static], [constexpr]

Minimum protocol version required for the set_fullscreen function.

Definition at line 1743 of file wayland-client-protocol.hpp.

  std::uint32_t wayland::shell_surface_t::set_maximized_since_version = 1 [static], [constexpr]

Minimum protocol version required for the set_maximized function.

Definition at line 1807 of file wayland-client-protocol.hpp.

  std::uint32_t wayland::shell_surface_t::set_popup_since_version = 1 [static], [constexpr]

Minimum protocol version required for the set_popup function.

Definition at line 1778 of file wayland-client-protocol.hpp.

  std::uint32_t wayland::shell_surface_t::set_title_since_version = 1 [static], [constexpr]

Minimum protocol version required for the set_title function.

Definition at line 1825 of file wayland-client-protocol.hpp.

  std::uint32_t wayland::shell_surface_t::set_toplevel_since_version = 1 [static], [constexpr]

Minimum protocol version required for the set_toplevel function.

Definition at line 1676 of file wayland-client-protocol.hpp.

  std::uint32_t wayland::shell_surface_t::set_transient_since_version = 1 [static], [constexpr]

Minimum protocol version required for the set_transient function.

Definition at line 1697 of file wayland-client-protocol.hpp.

Author

Generated automatically by Doxygen for Wayland++ from the source code.